<template>
    <v-row>
        <v-col>
            <v-skeleton-loader
                v-if="isEditMode"
                :loading="loading"
                transition="scale-transition"
                height="48"
                type="image"
            >
                <v-tabs
                    v-if="isEditMode"
                    fixed-tabs
                    background-color="indigo darken-2"
                    dark
                >
                    <v-tab class="font-weight-bold" :to="'/product/edit/' + localValue.id">
                        <v-icon>mdi-store</v-icon>
                    </v-tab>

                    <v-tab class="font-weight-bold" :to="'/product/stock/' + localValue.id">
                        {{ $tc('stock', 2) }}
                    </v-tab>
                </v-tabs>
            </v-skeleton-loader>
            <v-card>
                <ValidationObserver ref="observer" v-slot="{ validate, reset }">
                    <v-container class="px-8">
                        <v-row class="pb-2">
                            <v-col cols="4" md="4" class="align-self-center flex-grow-1 flex-shrink-0">
                                <div class="title text--primary fill-height">
                                    {{ $t(mode + '_', [$t('product')]) }}
                                </div>
                            </v-col>

                            <v-spacer></v-spacer>

                            <v-col md="2" class="flex-grow-0 flex-shrink-1">
                                <v-switch class="toggle"
                                          v-model="localValue.most_popular"
                                          :label="$t('most_popular')"
                                          :true-value="1"
                                          :false-value="0"
                                          inset
                                          hide-details
                                >
                                </v-switch>
                            </v-col>

                            <v-col md="2" class="flex-grow-0 flex-shrink-1">
                                <v-switch class="toggle"
                                          v-model="localValue.new_arrival"
                                          :label="$t('new_arrival')"
                                          :true-value="1"
                                          :false-value="0"
                                          inset
                                          hide-details
                                >
                                </v-switch>
                            </v-col>

                            <v-col class="flex-grow-0 flex-shrink-1">
                                <v-switch class="toggle"
                                          v-model="localValue.featured"
                                          :label="$t('feature')"
                                          :true-value="1"
                                          :false-value="0"
                                          inset
                                          hide-details
                                >
                                </v-switch>
                            </v-col>

                            <v-col class="flex-grow-0 flex-shrink-1">
                                <v-switch class="toggle"
                                          v-model="localValue.enabled"
                                          :label="$t('enabled')"
                                          :true-value="1"
                                          :false-value="0"
                                          inset
                                          hide-details
                                >
                                </v-switch>
                            </v-col>
                        </v-row>

                        <v-divider></v-divider>

                        <v-row>
                            <v-col>
                                <div class="subtitle-1 text--secondary">
                                    {{ $t('product_', [$tc('category', 2)]) }}
                                </div>
                            </v-col>
                        </v-row>

                        <v-row class="ml-2">
                            <v-col  cols="12">
                                <div class="field-label">{{ $t('business_type') }}</div>
                                <ValidationProvider v-slot="{ errors }" :name="$t('business_type')" rules="required">
                                    <v-business-type-select
                                        v-model="localValue.business_type_id"
                                        :errors="errors"
                                        :placeholder="$t('business_type')"
                                        outlined
                                        v-if="!isEditMode"
                                    >
                                    </v-business-type-select>

                                    <v-text-field
                                        v-model="localValue.business_type_name"
                                        :error-messages="errors"
                                        :placeholder="$t('business_type')"
                                        outlined
                                        readonly
                                        v-if="isEditMode"
                                    >
                                    </v-text-field>

                                </ValidationProvider>
                            </v-col>
                             <v-col  cols="12">
                                <div class="field-label">{{ $tc('collection', 1) }}</div>
                                <ValidationProvider v-slot="{ errors }" :name="$tc('collection', 1)" rules="required">
                                    <v-product-type-select
                                        v-model="localValue.product_type_id"
                                        :errors="errors"
                                        :placeholder="$t('product_', [$tc('collection', 1)])"
                                        outlined
                                        ref="productType"
                                    >
                                    </v-product-type-select>
                                </ValidationProvider>
                            </v-col>

                            <v-col cols="12">
                                <div class="field-label">{{ $tc('category', 2) }}</div>
                                <ValidationProvider v-slot="{ errors }" :name="$tc('category', 2)" rules="required">
                                    <v-category-select
                                        v-model="localValue.category_ids"
                                        :errors="errors"
                                        :placeholder="$t('product_', [$tc('category', 2)])"
                                        outlined
                                        ref="category"
                                    >
                                    </v-category-select>
                                </ValidationProvider>
                            </v-col>

                            <v-col>
                                <div class="field-label">{{ $tc('brand', 1) }}</div>
                                <ValidationProvider v-slot="{ errors }" :name="$tc('brand', 1)" rules="required">
                                    <v-brand-select
                                        v-model="localValue.brand_id"
                                        :errors="errors"
                                        :placeholder="$t('product_', [$tc('brand', 1)])"
                                        outlined
                                    >
                                    </v-brand-select>
                                </ValidationProvider>
                            </v-col>

                            <v-col>
                                <div class="field-label">{{ $tc('gender', 1) }}</div>
                                <ValidationProvider v-slot="{ errors }" :name="$tc('gender', 1)" rules="required">
                                    <v-gender-select
                                        v-model="localValue.gender_id"
                                        :errors="errors"
                                        :placeholder="$t('product_', [$tc('gender', 1)])"
                                        outlined
                                    >
                                    </v-gender-select>
                                </ValidationProvider>
                            </v-col>
                        </v-row>

                        <v-divider></v-divider>

                        <v-row>
                            <v-col>
                                <div class="subtitle-1 text--secondary">
                                    {{ $t('product_', [$t('info')]) }}
                                </div>
                            </v-col>
                        </v-row>

                        <v-row class="ml-2">
                            <v-col cols="12">
                                <div class="field-label">{{ $t('name') }}</div>
                                <ValidationProvider v-slot="{ errors }" name="name" rules="required">
                                    <v-text-field
                                        v-model="localValue.name"
                                        :error-messages="errors"
                                        :placeholder="$t('product_', [$t('name')])"
                                        outlined
                                    >
                                    </v-text-field>
                                </ValidationProvider>
                            </v-col>
                        </v-row>

                        <v-row class="ml-2">
                            <v-col cols="12" v-if="!isEditMode">
                                <v-tooltip top max-width="200">
                                    <template v-slot:activator="{ on, attrs }">
                                        <v-icon
                                            color="primary"
                                            dark
                                            v-bind="attrs"
                                            v-on="on"
                                        >
                                            mdi-alert-circle-outline
                                        </v-icon>
                                    </template>
                                    <span>{{ $t('slug_desc') }}</span>
                                </v-tooltip>
                                <div class="d-inline-block field-label">{{ $t('slug') }}</div>
                                <ValidationProvider v-slot="{ errors }" name="slug" rules="required">
                                    <v-text-field
                                        v-model="localValue.slug"
                                        :error-messages="errors"
                                        :placeholder="$t('product_', [$t('slug')])"
                                        outlined
                                    >
                                    </v-text-field>
                                </ValidationProvider>
                            </v-col>

                            <v-col cols="12">
                                <div class="field-label">{{ $t('description') }}</div>
                                <ValidationProvider v-slot="{ errors }" name="description" rules="required">
                                    <text-editor
                                        v-model="localValue.description"
                                        :errors="errors"
                                    >
                                    </text-editor>
                                </ValidationProvider>
                            </v-col>

                            <v-col cols="12">
                                <div class="field-label d-inline-flex">{{ $t('sku') }}</div>
                                <div v-if="!isEditMode" class="d-inline-flex">
                                    <ValidationProvider rules="" name="autoSKU">
                                        <v-switch class="toggle pl-4"
                                                  v-model="autoSKU"
                                                  :label="$t('sku_desc')"
                                                  inset
                                                  hide-details
                                        >
                                        </v-switch>
                                    </ValidationProvider>
                                </div>
                                <ValidationProvider v-slot="{ errors }" name="sku" :rules="skuRules">
                                    <v-text-field
                                        v-model="localValue.sku"
                                        :error-messages="errors"
                                        :placeholder="$t('product_', [$t('sku')])"
                                        :disabled="isEditMode ? false : autoSKU"
                                        outlined
                                    >
                                    </v-text-field>
                                </ValidationProvider>
                            </v-col>
                        </v-row>

                        <v-divider></v-divider>

                        <v-row>
                            <v-col>
                                <div class="subtitle-1 text--secondary">
                                    {{ $t('product_', [$t('pricing')]) }}
                                </div>
                            </v-col>
                        </v-row>

                        <v-row class="ml-2">
                            <v-col>
                                <div class="field-label">{{ $t('price') }}</div>
                                <ValidationProvider v-slot="{ errors }" name="price" rules="required|min_value:1|decimal">
                                    <v-text-field
                                        v-model="localValue.price"
                                        prefix="MYR"
                                        type="number"
                                        :error-messages="errors"
                                        :placeholder="$t('product_', [$t('price')])"
                                        outlined
                                    >
                                    </v-text-field>
                                </ValidationProvider>
                            </v-col>

                            <v-col>
                                <div class="field-label">{{ $t('cost_price') }}</div>
                                <ValidationProvider v-slot="{ errors }" name="cost_price" rules="required|min_value:1|decimal">
                                    <v-text-field
                                        v-model="localValue.cost_price"
                                        prefix="MYR"
                                        type="number"
                                        :error-messages="errors"
                                        :placeholder="$t('product_', [$t('cost_price')])"
                                        outlined
                                    >
                                    </v-text-field>
                                </ValidationProvider>
                            </v-col>
                        </v-row>

                        <v-divider></v-divider>

                        <v-row>
                            <v-col>
                                <div class="subtitle-1 text--secondary">
                                    {{ $t('product_', [$t('preview')]) }}
                                </div>
                            </v-col>
                        </v-row>

                        <div class="pb-5">
                            <ValidationProvider v-slot="{ errors }" name="image" :rules="`${!isEditMode ? 'required' : ''}`">
                                <v-image-input
                                    class="ml-2"
                                    v-model="localValue.images"
                                    :mode="mode"
                                    :errors="errors"
                                    :placeholder="$t('product_', [$t('image')])"
                                >
                                </v-image-input>
                            </ValidationProvider>
                        </div>

                        <template v-if="isEditMode">
                            <v-divider class="pb-2"></v-divider>

                            <v-row>
                                <v-col>
                                    <div class="subtitle-1 text--secondary">
                                        {{ $t('product_', [$t('uploaded_image')]) }}
                                    </div>
                                </v-col>
                            </v-row>

                            <product-image-editor
                                class="ml-2 pb-5"
                                v-model="localValue.uploaded_images"
                                @deleted="onDeleteUploadedImage"
                                @move="onUploadedImageMove"
                            >
                            </product-image-editor>
                        </template>

                        <v-divider class="py-2"></v-divider>

                        <template v-if="(hasVariants || !!localValue.variants.length) && !isEditMode">
                            <v-row>
                                <v-col>
                                    <div class="subtitle-1 text--secondary">
                                        {{ $t('vendor') }}
                                    </div>
                                </v-col>
                            </v-row>

                            <v-row class="ml-2">

                                <v-col cols="12" class="pb-5">
                                    <v-checkbox
                                        class="mt-0"
                                        v-model="hasSameVendor"
                                        :label="$t('vendor_desc')"
                                        hide-details
                                    >
                                    </v-checkbox>
                                </v-col>

                                <v-col v-if="hasSameVendor">
                                    <div class="field-label">{{ $t('vendor') }}</div>
                                    <ValidationProvider v-slot="{ errors }" name="vendor" >
                                        <vendor-select
                                            v-model="localValue.vendor"
                                            :placeholder="$t('product_', [$t('vendor')])"
                                            :errors="errors"
                                        >
                                        </vendor-select>
                                    </ValidationProvider>
                                </v-col>
                            </v-row>
                            <v-divider class="py-2"></v-divider>
                        </template>

                        <v-row>
                            <v-col>
                                <div class="subtitle-1 text--secondary">
                                    {{ $t('product_', [$tc('variant', 1)]) }}
                                </div>
                            </v-col>
                        </v-row>

                        <v-row class="ml-2">
                            <v-col cols="12" class="py-0" v-if="!isEditMode">
                                <v-checkbox
                                    v-model="hasVariants"
                                    :label="$t('variant_desc')"
                                    hide-details
                                >
                                </v-checkbox>
                            </v-col>

                            <v-col cols="12" class="py-0" v-else-if="isEditMode">
                                <v-checkbox
                                    :value ="localValue.variants.length > 0 ? true : false"
                                    v-model="hasVariants"
                                    :label="$t('variant_desc')"
                                    hide-details
                                    :disabled = "localValue.variants.length > 0 ? true : false"
                                >
                                </v-checkbox>
                            </v-col>

                            <v-col v-if="hasVariants || !!localValue.variants.length">
                                <ValidationProvider v-slot="{ errors }" name="variants" rules="required">
                                    <variant-box
                                        v-model="localValue.variants"
                                        :errors="errors"
                                        ref="VariantBox"
                                    >
                                    </variant-box>
                                </ValidationProvider>
                            </v-col>
                        </v-row>

                        <v-row class="pt-5">
                            <v-col class="text-center">
                                <v-btn
                                    v-if="clearable"
                                    class="text--white mx-2"
                                    color="error"
                                    :loading="submit"
                                    @click="internalClear"
                                    large
                                >
                                    <v-icon>mdi-close</v-icon>
                                    {{ $t('clear') }}
                                </v-btn>
                                <v-btn
                                    class="text--white mx-2"
                                    color="primary"
                                    :loading="submit"
                                    @click="internalSave"
                                    large
                                >
                                    <v-icon>mdi-content-save</v-icon>
                                    {{ $t('save') }}
                                </v-btn>
                            </v-col>
                        </v-row>
                    </v-container>
                </ValidationObserver>
            </v-card>
        </v-col>
    </v-row>
</template>

<script>
    import { ValidationObserver, ValidationProvider } from 'vee-validate';
    import VTelInput from "../VTelInput";
    import util from "../../../mixins/util"
    import VStockStatusSelect from "../VStockStatusSelect";
    import VendorSelect from "../VendorSelect";
    import VCategorySelect from "../VCategorySelect";
    import VImageInput from "../VImageInput";
    import VDiscountInput from "../VDiscountInput";
    import VariantBox from "../VariantBox";
    import TextEditor from "../editor/TextEditor";
    import VBrandSelect from "../VBrandSelect";
    import VBusinessTypeSelect from "../VBusinessTypeSelect";
    import VProductTypeSelect from "../VProductTypeSelect";
    import VGenderSelect from "../VGenderSelect";
    import ProductImageEditor from "./ProductImageEditor";
    import { mapMutations } from "vuex";

    export default {
        name: "ProductForm",
        components: {
            VBusinessTypeSelect,
            ProductImageEditor,
            VGenderSelect,
            VProductTypeSelect,
            VBrandSelect,
            TextEditor,
            VariantBox,
            VDiscountInput,
            VImageInput,
            VCategorySelect,
            VStockStatusSelect,
            VendorSelect,
            VTelInput,
            ValidationObserver,
            ValidationProvider
        },
        mixins: [ util ],

        props: {
            loading: {
                type: Boolean,
                default: false,
            },
            value: {
                type: Object,
                required: true
            },
            clearable: {
                type: Boolean,
                default: true
            },
            mode: {
                type: String,
                default: 'create',
                validator: value => ['create', 'edit'].indexOf(value) !== -1
            }
        },

        data: () => ({
            dirtySlug: false,
            autoSKU: true,
            submit: false,
            dateMenu: false,
            hasVariants: false,
            hasSameVendor: false,
            isUploadedImagesDirty: false
        }),

        watch: {
            'value.name'(val) {
                if(!this.isEditMode) {
                    const slug = _.kebabCase(val);

                    if(this.localValue.slug === slug) return;

                    this.localValue.slug = slug;
                }
            },
            'value.business_type_id'(val) {
                if (val === null) val = 1; // 1 = Rent
                this.$refs.productType.fetchProductTypes(val);
                this.$refs.category.fetchCategories(val);

                if(!this.isEditMode ) {
                    this.localValue.category_ids = [];
                    this.localValue.product_type_id = null;
                }
            }
        },

        computed: {
            isEditMode() {
                return this.mode === 'edit';
            },

            skuRules() {
                if(this.isEditMode) {
                    return 'required';
                }
                else {
                    return {
                        required_if: {
                            target: 'autoSKU',
                            values: ['false']
                        }
                    }
                }
            },

            localValue: {
                get() {
                    return this.value;
                },
                set(val) {
                    this.$emit('input', val);
                }
            }
        },

        methods: {
            ...mapMutations('snackbar', [
                'success',
                'error'
            ]),

            internalClear() {
                let defaultObject = {
                    name: '',
                    descriptions:'',
                    price: 0,
                    cost_price: 0,
                    discount: 0,
                    discount_type_id: 2,
                    images: [],
                    available_date: null,
                    category_ids: [],
                    gender_id: null,
                    brand_id: null,
                    product_type_id: null,
                    variants: [],
                    new_arrival: 0,
                    most_popular: 0,
                    featured: 0,
                    enabled: 1,
                    vendor:null,
                };

                this.$emit('input', defaultObject);

                this.$refs.observer.reset();
            },

            internalSave() {
                this.submit = true;
                if((this.hasVariants || this.isEditMode) && this.$refs.VariantBox){
                    this.$refs.VariantBox.addVariant(true);
                }
                this.$refs.observer.validate()
                    .then(valid => {
                        if(valid) {
                            this.callApi()
                                .then(data => {
                                    this.submit = false;
                                    if (data.status === 200) {
                                        this.$router.push('/product');
                                    }
                                })
                                .catch(data => {
                                    if (data && data.includes('413')) {
                                        this.error(this.$t('file_too_large'));
                                    }
                                    else {
                                        this.$refs.observer.setErrors(data.errors);
                                    }
                                })
                                .finally(() => {
                                    this.submit = false;
                                })
                        }
                        else {
                            this.submit = false;
                        }
                    })
            },

            callApi() {
                if(this.isEditMode) {
                    return new Promise(( resolve, reject ) => {
                        let formData = this.prepareData();
                        formData.append("_method", "put");

                        axios.post(`api/products/${this.localValue.id}`, formData)
                            .then(response => {
                                this.success(this.$t('product_action.updated'));

                                resolve({
                                    status: response.status,
                                    data: response.data
                                })
                            })
                            .catch(error => {
                                let fields = ['name' , 'description' , 'slug' , 'sku' , 'price' , 'images' , 'gender_id' , 'brand_id' , 'product_type_id' , 'variants' , 'enabled' , 'featured' , 'new_arrival' , 'most_popular']
                                let message = error.response.data.message

                                for(let i=0; i < fields.length; i++){
                                    if(error.response.data.errors && fields[i] in error.response.data.errors){
                                        let field = fields[i];
                                        message = error.response.data.errors[field][0]
                                        break;
                                    }
                                }

                                this.error(message)
                                this.$refs.observer.setErrors(message)
                                reject(error.response.data)
                            })
                    })
                }
                else {
                    return new Promise(( resolve, reject ) => {
                        axios.post('api/products', this.prepareData())
                            .then(response => {
                                this.success(this.$t('product_action.created'));
                                resolve({
                                    status: response.status
                                })
                            })
                            .catch(error => {
                                let fields = ['name' , 'description' , 'slug' , 'sku' , 'price' , 'cost_price' , 'images' , 'gender_id' , 'brand_id' , 'product_type_id' , 'variants' , 'enabled' , 'featured' , 'new_arrival' , 'most_popular']
                                let message = error.response.data.message

                                for(let i=0; i < fields.length; i++){
                                    if(error.response.data.errors && fields[i] in error.response.data.errors){
                                        let field = fields[i];
                                        message = error.response.data.errors[field][0]
                                        break;
                                    }
                                }

                                this.error(message)
                                this.$refs.observer.setErrors(message);
                                reject(error.response.data)
                            })
                    })
                }
            },

            prepareData() {
                let data = { ...this.localValue };

                if(!this.isUploadedImagesDirty) {
                    delete data.uploaded_images;
                }

                return this.objectToFormData(data);
            },

            onDeleteUploadedImage(id) {
                this.localValue.deleted_images.push(id);
            },

            onUploadedImageMove(images) {
                this.isUploadedImagesDirty = true;
            }
        }
    }
</script>

<style>
    .toggle.v-input--selection-controls {
        margin-top: 0 !important;
    }
</style>
